using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using System.Reflection;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
            //Pistols
            ModAPI.Register(
                new Modification()
                {
                OriginalItem = ModAPI.FindSpawnable("Pistol"),
                NameOverride = "Blue Laser Pistol -Laser Tag Mod", 
                DescriptionOverride = "Blue Pew Pew Pow", 
                CategoryOverride = ModAPI.FindCategory("Firearms"), 
                ThumbnailOverride = ModAPI.LoadSprite("Textures/BlueLaserPistol.png"), 
                AfterSpawn = (Instance) => 
                {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlueLaserPistol.png");


                var firearm = Instance.GetComponent<FirearmBehaviour>();

            
                Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); 
                customCartridge.name = "Laser Pistol"; 
                customCartridge.Damage *= 0.1f; 
                customCartridge.StartSpeed *= 1.0f; 
                customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                customCartridge.Recoil *= 0.1f; 
                customCartridge.ImpactForce *= 0.2f; 

            
                firearm.Cartridge = customCartridge;

            
                firearm.ShotSounds = new AudioClip[]
                {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                };
                Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                OriginalItem = ModAPI.FindSpawnable("Pistol"),
                NameOverride = "Red Laser Pistol -Laser Tag Mod", 
                DescriptionOverride = "Red Pew Pew Pow", 
                CategoryOverride = ModAPI.FindCategory("Firearms"), 
                ThumbnailOverride = ModAPI.LoadSprite("Textures/RedLaserPistol.png"), 
                AfterSpawn = (Instance) => 
                {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/RedLaserPistol.png");


                var firearm = Instance.GetComponent<FirearmBehaviour>();

            
                Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); 
                customCartridge.name = "Laser Pistol"; 
                customCartridge.Damage *= 0.1f; 
                customCartridge.StartSpeed *= 1.0f; 
                customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                customCartridge.Recoil *= 0.1f; 
                customCartridge.ImpactForce *= 0.2f; 

            
                firearm.Cartridge = customCartridge;

            
                firearm.ShotSounds = new AudioClip[]
                {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                };
                Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                OriginalItem = ModAPI.FindSpawnable("Pistol"),
                NameOverride = "Green Laser Pistol -Laser Tag Mod", 
                DescriptionOverride = "Green Pew Pew Pow", 
                CategoryOverride = ModAPI.FindCategory("Firearms"), 
                ThumbnailOverride = ModAPI.LoadSprite("Textures/GreenLaserPistol.png"), 
                AfterSpawn = (Instance) => 
                {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/GreenLaserPistol.png");


                var firearm = Instance.GetComponent<FirearmBehaviour>();

            
                Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); 
                customCartridge.name = "Laser Pistol"; 
                customCartridge.Damage *= 0.1f; 
                customCartridge.StartSpeed *= 1.0f; 
                customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                customCartridge.Recoil *= 0.1f; 
                customCartridge.ImpactForce *= 0.2f; 

            
                firearm.Cartridge = customCartridge;

            
                firearm.ShotSounds = new AudioClip[]
                {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                };
                Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                OriginalItem = ModAPI.FindSpawnable("Pistol"),
                NameOverride = "Yellow Laser Pistol -Laser Tag Mod", 
                DescriptionOverride = "Yellow Pew Pew Pow", 
                CategoryOverride = ModAPI.FindCategory("Firearms"), 
                ThumbnailOverride = ModAPI.LoadSprite("Textures/YellowLaserPistol.png"), 
                AfterSpawn = (Instance) => 
                {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/YellowLaserPistol.png");


                var firearm = Instance.GetComponent<FirearmBehaviour>();

            
                Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); 
                customCartridge.name = "Laser Pistol"; 
                customCartridge.Damage *= 0.1f; 
                customCartridge.StartSpeed *= 1.0f; 
                customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                customCartridge.Recoil *= 0.1f; 
                customCartridge.ImpactForce *= 0.2f; 

            
                firearm.Cartridge = customCartridge;

            
                firearm.ShotSounds = new AudioClip[]
                {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                };
                Instance.FixColliders();
                    }
                }
            );


            //Revolvers
            ModAPI.Register(
                new Modification()
                {
                OriginalItem = ModAPI.FindSpawnable("Revolver"),
                NameOverride = "Blue Laser Revolver -Laser Tag Mod", 
                DescriptionOverride = "Blue Pew Pow Pow", 
                CategoryOverride = ModAPI.FindCategory("Firearms"), 
                ThumbnailOverride = ModAPI.LoadSprite("Textures/BlueLaserRevolver.png"), 
                AfterSpawn = (Instance) => 
                {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlueLaserRevolver.png");


                var firearm = Instance.GetComponent<FirearmBehaviour>();

            
                Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); 
                customCartridge.name = "Laser Revolver"; 
                customCartridge.Damage *= 0.2f; 
                customCartridge.StartSpeed *= 1.0f; 
                customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                customCartridge.Recoil *= 0.1f; 
                customCartridge.ImpactForce *= 0.3f; 

            
                firearm.Cartridge = customCartridge;

            
                firearm.ShotSounds = new AudioClip[]
                {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                };
                Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                OriginalItem = ModAPI.FindSpawnable("Revolver"),
                NameOverride = "Red Laser Revolver -Laser Tag Mod", 
                DescriptionOverride = "Red Pew Pow Pow", 
                CategoryOverride = ModAPI.FindCategory("Firearms"), 
                ThumbnailOverride = ModAPI.LoadSprite("Textures/RedLaserRevolver.png"), 
                AfterSpawn = (Instance) => 
                {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/RedLaserRevolver.png");


                var firearm = Instance.GetComponent<FirearmBehaviour>();

            
                Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); 
                customCartridge.name = "Laser Revolver"; 
                customCartridge.Damage *= 0.2f; 
                customCartridge.StartSpeed *= 1.0f; 
                customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                customCartridge.Recoil *= 0.1f; 
                customCartridge.ImpactForce *= 0.3f; 

            
                firearm.Cartridge = customCartridge;

            
                firearm.ShotSounds = new AudioClip[]
                {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                };
                Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                OriginalItem = ModAPI.FindSpawnable("Revolver"),
                NameOverride = "Green Laser Revolver -Laser Tag Mod", 
                DescriptionOverride = "Green Pew Pow Pow", 
                CategoryOverride = ModAPI.FindCategory("Firearms"), 
                ThumbnailOverride = ModAPI.LoadSprite("Textures/GreenLaserRevolver.png"), 
                AfterSpawn = (Instance) => 
                {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/GreenLaserRevolver.png");


                var firearm = Instance.GetComponent<FirearmBehaviour>();

            
                Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); 
                customCartridge.name = "Laser Revolver"; 
                customCartridge.Damage *= 0.2f; 
                customCartridge.StartSpeed *= 1.0f; 
                customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                customCartridge.Recoil *= 0.1f; 
                customCartridge.ImpactForce *= 0.3f; 

            
                firearm.Cartridge = customCartridge;

            
                firearm.ShotSounds = new AudioClip[]
                {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                };
                Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                OriginalItem = ModAPI.FindSpawnable("Revolver"),
                NameOverride = "Yellow Laser Revolver -Laser Tag Mod", 
                DescriptionOverride = "Yellow Pew Pow Pow", 
                CategoryOverride = ModAPI.FindCategory("Firearms"), 
                ThumbnailOverride = ModAPI.LoadSprite("Textures/YellowLaserRevolver.png"), 
                AfterSpawn = (Instance) => 
                {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/YellowLaserRevolver.png");


                var firearm = Instance.GetComponent<FirearmBehaviour>();

            
                Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); 
                customCartridge.name = "Laser Revolver"; 
                customCartridge.Damage *= 0.2f; 
                customCartridge.StartSpeed *= 1.0f; 
                customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                customCartridge.Recoil *= 0.1f; 
                customCartridge.ImpactForce *= 0.3f; 

            
                firearm.Cartridge = customCartridge;

            
                firearm.ShotSounds = new AudioClip[]
                {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                };
                Instance.FixColliders();
                    }
                }
            );


            //SMGs
            ModAPI.Register(
                new Modification()
                {
                OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
                NameOverride = "Blue Laser SMG -Laser Tag Mod", 
                DescriptionOverride = "Blue Pew Pew Pew", 
                CategoryOverride = ModAPI.FindCategory("Firearms"), 
                ThumbnailOverride = ModAPI.LoadSprite("Textures/BlueLaserSMG.png"), 
                AfterSpawn = (Instance) => 
                {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlueLaserSMG.png");


                var firearm = Instance.GetComponent<FirearmBehaviour>();

            
                Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); 
                customCartridge.name = "Laser SMG"; 
                customCartridge.Damage *= 0.3f; 
                customCartridge.StartSpeed *= 1.0f; 
                customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                customCartridge.Recoil *= 0.3f; 
                customCartridge.ImpactForce *= 0.4f; 

            
                firearm.Cartridge = customCartridge;

            
                firearm.ShotSounds = new AudioClip[]
                {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                };
                Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
                NameOverride = "Red Laser SMG -Laser Tag Mod", 
                DescriptionOverride = "Red Pew Pew Pew", 
                CategoryOverride = ModAPI.FindCategory("Firearms"), 
                ThumbnailOverride = ModAPI.LoadSprite("Textures/RedLaserSMG.png"), 
                AfterSpawn = (Instance) => 
                {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/RedLaserSMG.png");


                var firearm = Instance.GetComponent<FirearmBehaviour>();

            
                Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); 
                customCartridge.name = "Laser SMG"; 
                customCartridge.Damage *= 0.3f; 
                customCartridge.StartSpeed *= 1.0f; 
                customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                customCartridge.Recoil *= 0.3f; 
                customCartridge.ImpactForce *= 0.4f; 

            
                firearm.Cartridge = customCartridge;

            
                firearm.ShotSounds = new AudioClip[]
                {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                };
                Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
                NameOverride = "Green Laser SMG -Laser Tag Mod", 
                DescriptionOverride = "Green Pew Pew Pew", 
                CategoryOverride = ModAPI.FindCategory("Firearms"), 
                ThumbnailOverride = ModAPI.LoadSprite("Textures/GreenLaserSMG.png"), 
                AfterSpawn = (Instance) => 
                {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/GreenLaserSMG.png");


                var firearm = Instance.GetComponent<FirearmBehaviour>();

            
                Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); 
                customCartridge.name = "Laser SMG"; 
                customCartridge.Damage *= 0.3f; 
                customCartridge.StartSpeed *= 1.0f; 
                customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                customCartridge.Recoil *= 0.3f; 
                customCartridge.ImpactForce *= 0.4f; 

            
                firearm.Cartridge = customCartridge;

            
                firearm.ShotSounds = new AudioClip[]
                {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                };
                Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
                NameOverride = "Yellow Laser SMG -Laser Tag Mod", 
                DescriptionOverride = "Yellow Pew Pew Pew", 
                CategoryOverride = ModAPI.FindCategory("Firearms"), 
                ThumbnailOverride = ModAPI.LoadSprite("Textures/YellowLaserSMG.png"), 
                AfterSpawn = (Instance) => 
                {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/YellowLaserSMG.png");


                var firearm = Instance.GetComponent<FirearmBehaviour>();

            
                Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); 
                customCartridge.name = "Laser SMG"; 
                customCartridge.Damage *= 0.3f; 
                customCartridge.StartSpeed *= 1.0f; 
                customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                customCartridge.Recoil *= 0.3f; 
                customCartridge.ImpactForce *= 0.4f; 

            
                firearm.Cartridge = customCartridge;

            
                firearm.ShotSounds = new AudioClip[]
                {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                };
                Instance.FixColliders();
                    }
                }
            );


            //ARs
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                    NameOverride = "Blue Laser Rifle -Laser Tag Mod",
                    DescriptionOverride = "Blue Pow Pow Pew",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/BlueLaserAR.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlueLaserAR.png");


                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "Laser Rifle";
                        customCartridge.Damage *= 0.5f;
                        customCartridge.StartSpeed *= 1.0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                        customCartridge.Recoil *= 0.5f;
                        customCartridge.ImpactForce *= 0.6f;


                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                        };
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                    NameOverride = "Red Laser Rifle -Laser Tag Mod",
                    DescriptionOverride = "Red Pow Pow Pew",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/RedLaserAR.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/RedLaserAR.png");


                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "Laser Rifle";
                        customCartridge.Damage *= 0.5f;
                        customCartridge.StartSpeed *= 1.0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                        customCartridge.Recoil *= 0.5f;
                        customCartridge.ImpactForce *= 0.6f;


                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                        };
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                    NameOverride = "Green Laser Rifle -Laser Tag Mod",
                    DescriptionOverride = "Blue Pow Pow Pew",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/GreenLaserAR.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/GreenLaserAR.png");


                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "Laser Rifle";
                        customCartridge.Damage *= 0.5f;
                        customCartridge.StartSpeed *= 1.0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                        customCartridge.Recoil *= 0.5f;
                        customCartridge.ImpactForce *= 0.6f;


                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                        };
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                    NameOverride = "Yellow Laser Rifle -Laser Tag Mod",
                    DescriptionOverride = "Yellow Pow Pow Pew",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/YellowLaserAR.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/YellowLaserAR.png");


                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "Laser Rifle";
                        customCartridge.Damage *= 0.5f;
                        customCartridge.StartSpeed *= 1.0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                        customCartridge.Recoil *= 0.5f;
                        customCartridge.ImpactForce *= 0.6f;


                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                        };
                        Instance.FixColliders();
                    }
                }
            );


            //AKs
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("AK-47"),
                    NameOverride = "Blue Laser AK-47 -Laser Tag Mod",
                    DescriptionOverride = "Blue Pow Pow Pew",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/BlueLaserAk.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlueLaserAk.png");


                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "Laser AK-47";
                        customCartridge.Damage *= 0.5f;
                        customCartridge.StartSpeed *= 1.0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                        customCartridge.Recoil *= 0.8f;
                        customCartridge.ImpactForce *= 0.7f;


                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                        };
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("AK-47"),
                    NameOverride = "Red Laser AK-47 -Laser Tag Mod",
                    DescriptionOverride = "Red Pow Pow Pew",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/RedLaserAk.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/RedLaserAk.png");


                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "Laser AK-47";
                        customCartridge.Damage *= 0.5f;
                        customCartridge.StartSpeed *= 1.0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                        customCartridge.Recoil *= 0.8f;
                        customCartridge.ImpactForce *= 0.7f;


                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                        };
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("AK-47"),
                    NameOverride = "Green Laser AK-47 -Laser Tag Mod",
                    DescriptionOverride = "Green Pow Pow Pew",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/GreenLaserAk.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/GreenLaserAk.png");


                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "Laser AK-47";
                        customCartridge.Damage *= 0.5f;
                        customCartridge.StartSpeed *= 1.0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                        customCartridge.Recoil *= 0.8f;
                        customCartridge.ImpactForce *= 0.7f;


                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                        };
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("AK-47"),
                    NameOverride = "Yellow Laser AK-47 -Laser Tag Mod",
                    DescriptionOverride = "Yellow Pow Pow Pew",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/YellowLaserAk.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/YellowLaserAk.png");


                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "Laser AK-47";
                        customCartridge.Damage *= 0.5f;
                        customCartridge.StartSpeed *= 1.0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                        customCartridge.Recoil *= 0.8f;
                        customCartridge.ImpactForce *= 0.7f;


                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound2.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                        };
                        Instance.FixColliders();
                    }
                }
            );


            //Snipers
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"),
                    NameOverride = "Blue Laser Sniper Rifle -Laser Tag Mod",
                    DescriptionOverride = "Blue POW",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/BlueLaserSniper.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlueLaserSniper.png");


                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "Laser Sniper Rifle";
                        customCartridge.Damage *= 1.0f;
                        customCartridge.StartSpeed *= 1.0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                        customCartridge.Recoil *= 1.0f;
                        customCartridge.ImpactForce *= 1.0f;


                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                        };
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"),
                    NameOverride = "Red Laser Sniper Rifle -Laser Tag Mod",
                    DescriptionOverride = "Red POW",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/RedLaserSniper.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/RedLaserSniper.png");


                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "Laser Sniper Rifle";
                        customCartridge.Damage *= 1.0f;
                        customCartridge.StartSpeed *= 1.0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                        customCartridge.Recoil *= 1.0f;
                        customCartridge.ImpactForce *= 1.0f;


                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                        };
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"),
                    NameOverride = "Green Laser Sniper Rifle -Laser Tag Mod",
                    DescriptionOverride = "Green POW",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/GreenLaserSniper.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/GreenLaserSniper.png");


                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "Laser Sniper Rifle";
                        customCartridge.Damage *= 1.0f;
                        customCartridge.StartSpeed *= 1.0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                        customCartridge.Recoil *= 1.0f;
                        customCartridge.ImpactForce *= 1.0f;


                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                        };
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"),
                    NameOverride = "Yellow Laser Sniper Rifle -Laser Tag Mod",
                    DescriptionOverride = "Yellow POW",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/YellowLaserSniper.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/YellowLaserSniper.png");


                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "Laser Sniper Rifle";
                        customCartridge.Damage *= 1.0f;
                        customCartridge.StartSpeed *= 1.0f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                        customCartridge.Recoil *= 1.0f;
                        customCartridge.ImpactForce *= 1.0f;


                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                ModAPI.LoadSound("Sounds/LaserSound1.wav"),
                ModAPI.LoadSound("Sounds/LaserSound3.wav"),
                        };
                        Instance.FixColliders();
                    }
                }
            );
        }
    }
}